﻿
// ProjectProgrammingDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "ProjectProgramming.h"
#include "ProjectProgrammingDlg.h"
#include "afxdialogex.h"
#include <sys/timeb.h>
#include <time.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////
UINT ThreadExecute(LPVOID pParam)
{
	CProjectProgrammingDlg* pObject = (CProjectProgrammingDlg *)pParam;
	pObject->Execute();
	return 0;
}

// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CProjectProgrammingDlg ダイアログ



CProjectProgrammingDlg::CProjectProgrammingDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_PROJECTPROGRAMMING_DIALOG, pParent)
	, m_strFilename(_T(""))
	, m_strCPUTime(_T(""))
	, m_strStatus(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProjectProgrammingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_OUTPUT, m_editOutput);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_strFilename);
	DDX_Text(pDX, IDC_EDIT_CPU_TIME, m_strCPUTime);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_strStatus);
}

BEGIN_MESSAGE_MAP(CProjectProgrammingDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_EXECUTION_DONE, &CProjectProgrammingDlg::OnExecutionDone)
	ON_BN_CLICKED(IDC_BUTTON_CHOOSE_FILE, &CProjectProgrammingDlg::OnBnClickedButtonChooseFile)
	ON_BN_CLICKED(IDC_BUTTON_EXEC, &CProjectProgrammingDlg::OnBnClickedButtonExec)
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CProjectProgrammingDlg メッセージ ハンドラー

BOOL CProjectProgrammingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	m_objOutput.SetEdit( &m_editOutput );
	m_objSolution.SetOutput( &m_objOutput );

	m_fontOutput.CreatePointFont( 110, _T("ＭＳ ゴシック"), NULL );
	m_editOutput.SetFont( &m_fontOutput, TRUE );

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CProjectProgrammingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CProjectProgrammingDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CProjectProgrammingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CProjectProgrammingDlg::OnBnClickedButtonChooseFile()
{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。
	CFileDialog FileDlg(TRUE, _T(".*") );
	TCHAR types[128],*p;
	CString str;
	//	char cPathName[1024];

	UpdateData(TRUE);
	p = types;
	str = "Data Files (*.txt)";
	lstrcpy( p, str );
	p += (str.GetLength()+1);
	str = "*.txt";
	//	str = "dfg_*.txt";
	lstrcpy( p, str );
	p += (str.GetLength()+1);
	str = "All Files (*.*)";
	lstrcpy( p, str );
	p += (str.GetLength()+1);
	str = "*.*";
	lstrcpy( p, str );
	p += (str.GetLength()+1);
	*p = 0x0;

	FileDlg.m_ofn.lpstrFilter = types;

	if( FileDlg.DoModal() != IDOK ) return;
	m_strFilename = FileDlg.GetPathName();
	UpdateData(FALSE);
	struct _stat buf;
	int result = _tstat( m_strFilename, &buf );
	/* ファイル状態情報が取得できたかのチェック */
	if( result != 0 ){
		AfxMessageBox( _T("データファイルが正しく読み込めません"), MB_ICONSTOP );
		return;
	}
	m_objSolution.SetFilename( m_strFilename );

	UpdateData( FALSE );
}

HBRUSH CProjectProgrammingDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO: ここで DC の属性を変更してください。
	
	switch( pWnd->GetDlgCtrlID() ){
	case IDC_EDIT_OUTPUT:
		pDC->SetTextColor( COLORREF(0xFFFFFF) );
		pDC->SetBkColor( COLORREF(0x333333)  );
		hbr = CreateSolidBrush( COLORREF(0x333333) );
		break;
	}
	// TODO: 既定値を使用したくない場合は別のブラシを返します。
	return hbr;
}

void CProjectProgrammingDlg::OnBnClickedButtonExec()
{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。

	//////////////////////////////////////////////////////////////////////////////////////////////
	m_pExecutingThread = ::AfxBeginThread( ThreadExecute, (LPVOID)this );
	m_pExecutingThread->m_bAutoDelete = FALSE;
	//	DWORD rthread = pSchedulingThread->ResumeThread();		// サスペンド解除
	m_strCPUTime = L"";
	m_strStatus = L"実行中...";
	UpdateData( FALSE );
	/*//////////////////////////////////////////////////////////////////////////////////////////////
	Execute();
	OnExecutionDone(0, 0);
	//////////////////////////////////////////////////////////////////////////////////////////////*/
}

void CProjectProgrammingDlg::Execute(void)
{
	m_objSolution.MarkTimeStart();
	m_objSolution.Execute();

	::PostMessage(m_hWnd, WM_EXECUTION_DONE, (WPARAM)0, (LPARAM)0 );
}

LRESULT CProjectProgrammingDlg::OnExecutionDone(WPARAM wParam, LPARAM lParam)
{
	int t0 = (int)wParam;
	int t1 = (int)lParam;
	unsigned long nCPUtime;

	nCPUtime = m_objSolution.GetRunTime();	// ミリ秒

	if( m_pExecutingThread ){
		DWORD dwExitCode;
		MSG    msg;
		do{
			if (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
			Sleep( 0 );
			GetExitCodeThread( m_pExecutingThread->m_hThread, &dwExitCode );
			//TRACE( "Thread: %d\n", dwExitCode );
		}while( dwExitCode == STILL_ACTIVE );
		if( m_pExecutingThread != NULL ){
			delete m_pExecutingThread;
		}
		m_pExecutingThread = NULL;
	}

	m_strCPUTime.Format( L"%.0f", (double)nCPUtime );
//	m_strCPUTime.Format( L"%.3f", (double)nCPUtime/1000.0 );
	m_strStatus = L"完了.";
	UpdateData(FALSE);

	return 0;
}

